import {
  useSwitch
} from "./chunk-IGQLURL7.mjs";

// src/switch.tsx
import { forwardRef } from "@nextui-org/system";
import { VisuallyHidden } from "@react-aria/visually-hidden";
import { cloneElement } from "react";
import { jsx, jsxs } from "react/jsx-runtime";
var Switch = forwardRef((props, ref) => {
  const {
    Component,
    children,
    leftIcon,
    rightIcon,
    thumbIcon,
    getBaseProps,
    getInputProps,
    getWrapperProps,
    getThumbProps,
    getThumbIconProps,
    getLabelProps,
    getLeftIconProps,
    getRightIconProps
  } = useSwitch({ ref, ...props });
  const clonedThumbIcon = typeof thumbIcon === "function" ? thumbIcon(getThumbIconProps({ includeStateProps: true })) : thumbIcon && cloneElement(thumbIcon, getThumbIconProps());
  const clonedLeftIcon = leftIcon && cloneElement(leftIcon, getLeftIconProps());
  const clonedRightIcon = rightIcon && cloneElement(rightIcon, getRightIconProps());
  return /* @__PURE__ */ jsxs(Component, { ...getBaseProps(), children: [
    /* @__PURE__ */ jsx(VisuallyHidden, { children: /* @__PURE__ */ jsx("input", { ...getInputProps() }) }),
    /* @__PURE__ */ jsxs("span", { ...getWrapperProps(), children: [
      leftIcon && clonedLeftIcon,
      /* @__PURE__ */ jsx("span", { ...getThumbProps(), children: thumbIcon && clonedThumbIcon }),
      rightIcon && clonedRightIcon
    ] }),
    children && /* @__PURE__ */ jsx("span", { ...getLabelProps(), children })
  ] });
});
Switch.displayName = "NextUI.Switch";
var switch_default = Switch;

export {
  switch_default
};
