"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Switch: () => switch_default,
  useSwitch: () => useSwitch
});
module.exports = __toCommonJS(src_exports);

// src/switch.tsx
var import_system2 = require("@nextui-org/system");
var import_visually_hidden = require("@react-aria/visually-hidden");
var import_react3 = require("react");

// src/use-switch.ts
var import_react = require("react");
var import_system = require("@nextui-org/system");
var import_interactions = require("@react-aria/interactions");
var import_theme = require("@nextui-org/theme");
var import_utils = require("@react-aria/utils");
var import_shared_utils = require("@nextui-org/shared-utils");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_switch = require("@react-aria/switch");
var import_react2 = require("react");
var import_toggle = require("@react-stately/toggle");
var import_focus = require("@react-aria/focus");
function useSwitch(originalProps) {
  const [props, variantProps] = (0, import_system.mapPropsVariants)(originalProps, import_theme.toggle.variantKeys);
  const {
    ref,
    as,
    name,
    value = "",
    isReadOnly = false,
    autoFocus = false,
    leftIcon,
    rightIcon,
    defaultSelected,
    isSelected: isSelectedProp,
    children,
    thumbIcon,
    className,
    styles,
    onChange,
    onValueChange,
    ...otherProps
  } = props;
  const Component = as || "label";
  const inputRef = (0, import_react.useRef)(null);
  const domRef = (0, import_dom_utils.useFocusableRef)(ref, inputRef);
  const labelId = (0, import_react.useId)();
  const ariaSwitchProps = (0, import_react2.useMemo)(() => {
    const ariaLabel = otherProps["aria-label"] || typeof children === "string" ? children : void 0;
    return {
      name,
      value,
      children,
      autoFocus,
      defaultSelected,
      isSelected: isSelectedProp,
      isDisabled: !!originalProps.isDisabled,
      isReadOnly,
      "aria-label": ariaLabel,
      "aria-labelledby": otherProps["aria-labelledby"] || labelId,
      onChange: onValueChange
    };
  }, [
    value,
    name,
    labelId,
    children,
    autoFocus,
    isSelectedProp,
    defaultSelected,
    originalProps.isDisabled,
    otherProps["aria-label"],
    otherProps["aria-labelledby"],
    onValueChange
  ]);
  const state = (0, import_toggle.useToggleState)(ariaSwitchProps);
  const { inputProps } = (0, import_switch.useSwitch)(ariaSwitchProps, state, inputRef);
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus.useFocusRing)({ autoFocus: inputProps.autoFocus });
  const { hoverProps, isHovered } = (0, import_interactions.useHover)({
    isDisabled: inputProps.disabled
  });
  const isSelected = inputProps.checked;
  const isDisabled = inputProps.disabled;
  const slots = (0, import_react2.useMemo)(
    () => (0, import_theme.toggle)({
      ...variantProps,
      isFocusVisible
    }),
    [...Object.values(variantProps), isFocusVisible]
  );
  const baseStyles = (0, import_shared_utils.clsx)(styles == null ? void 0 : styles.base, className);
  const getBaseProps = () => {
    return {
      ref: domRef,
      className: slots.base({ class: baseStyles }),
      "data-disabled": (0, import_shared_utils.dataAttr)(isDisabled),
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      ...(0, import_utils.mergeProps)(hoverProps, otherProps)
    };
  };
  const getWrapperProps = (0, import_react.useCallback)(() => {
    return {
      "data-hover": (0, import_shared_utils.dataAttr)(isHovered),
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      "data-focus": (0, import_shared_utils.dataAttr)(isFocused),
      "data-focus-visible": (0, import_shared_utils.dataAttr)(isFocused && isFocusVisible),
      "data-disabled": (0, import_shared_utils.dataAttr)(isDisabled),
      "data-readonly": (0, import_shared_utils.dataAttr)(inputProps.readOnly),
      "aria-hidden": true,
      className: (0, import_shared_utils.clsx)(slots.wrapper({ class: styles == null ? void 0 : styles.wrapper }))
    };
  }, [
    slots,
    styles == null ? void 0 : styles.wrapper,
    isHovered,
    isSelected,
    isFocused,
    isFocusVisible,
    isDisabled,
    inputProps.readOnly
  ]);
  const getInputProps = () => {
    return {
      ref: inputRef,
      id: inputProps.id,
      ...(0, import_utils.mergeProps)(inputProps, focusProps),
      onChange: (0, import_utils.chain)(onChange, inputProps.onChange)
    };
  };
  const getThumbProps = (0, import_react.useCallback)(
    () => ({
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      "data-focus": (0, import_shared_utils.dataAttr)(isFocused),
      "data-focus-visible": (0, import_shared_utils.dataAttr)(isFocused && isFocusVisible),
      "data-disabled": (0, import_shared_utils.dataAttr)(isDisabled),
      "data-readonly": (0, import_shared_utils.dataAttr)(inputProps.readOnly),
      className: slots.thumb({ class: styles == null ? void 0 : styles.thumb })
    }),
    [slots, styles == null ? void 0 : styles.thumb, isSelected, isFocused, isFocusVisible, isDisabled, inputProps.readOnly]
  );
  const getLabelProps = (0, import_react.useCallback)(
    () => ({
      id: labelId,
      "data-disabled": (0, import_shared_utils.dataAttr)(isDisabled),
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      className: slots.label({ class: styles == null ? void 0 : styles.label })
    }),
    [slots, styles == null ? void 0 : styles.label, isDisabled, isSelected]
  );
  const getThumbIconProps = (0, import_react.useCallback)(
    (props2 = {
      includeStateProps: false
    }) => (0, import_utils.mergeProps)(
      {
        width: "1em",
        height: "1em",
        "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
        className: slots.thumbIcon({ class: styles == null ? void 0 : styles.thumbIcon })
      },
      props2.includeStateProps ? {
        isSelected
      } : {}
    ),
    [slots, styles == null ? void 0 : styles.thumbIcon, isSelected, originalProps.disableAnimation]
  );
  const getLeftIconProps = (0, import_react.useCallback)(
    () => ({
      width: "1em",
      height: "1em",
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      className: slots.leftIcon({ class: styles == null ? void 0 : styles.leftIcon })
    }),
    [slots, styles == null ? void 0 : styles.leftIcon, isSelected]
  );
  const getRightIconProps = (0, import_react.useCallback)(
    () => ({
      width: "1em",
      height: "1em",
      "data-checked": (0, import_shared_utils.dataAttr)(isSelected),
      className: slots.rightIcon({ class: styles == null ? void 0 : styles.rightIcon })
    }),
    [slots, styles == null ? void 0 : styles.rightIcon, isSelected]
  );
  return {
    Component,
    slots,
    styles,
    domRef,
    children,
    thumbIcon,
    leftIcon,
    rightIcon,
    isHovered,
    isSelected,
    isFocused,
    isFocusVisible,
    isDisabled,
    getBaseProps,
    getWrapperProps,
    getInputProps,
    getLabelProps,
    getThumbProps,
    getThumbIconProps,
    getLeftIconProps,
    getRightIconProps
  };
}

// src/switch.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var Switch = (0, import_system2.forwardRef)((props, ref) => {
  const {
    Component,
    children,
    leftIcon,
    rightIcon,
    thumbIcon,
    getBaseProps,
    getInputProps,
    getWrapperProps,
    getThumbProps,
    getThumbIconProps,
    getLabelProps,
    getLeftIconProps,
    getRightIconProps
  } = useSwitch({ ref, ...props });
  const clonedThumbIcon = typeof thumbIcon === "function" ? thumbIcon(getThumbIconProps({ includeStateProps: true })) : thumbIcon && (0, import_react3.cloneElement)(thumbIcon, getThumbIconProps());
  const clonedLeftIcon = leftIcon && (0, import_react3.cloneElement)(leftIcon, getLeftIconProps());
  const clonedRightIcon = rightIcon && (0, import_react3.cloneElement)(rightIcon, getRightIconProps());
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(Component, { ...getBaseProps(), children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_visually_hidden.VisuallyHidden, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("input", { ...getInputProps() }) }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("span", { ...getWrapperProps(), children: [
      leftIcon && clonedLeftIcon,
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { ...getThumbProps(), children: thumbIcon && clonedThumbIcon }),
      rightIcon && clonedRightIcon
    ] }),
    children && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { ...getLabelProps(), children })
  ] });
});
Switch.displayName = "NextUI.Switch";
var switch_default = Switch;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Switch,
  useSwitch
});
